//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, vJAXB 2.1.10 in JDK 6 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.06.07 at 02:55:28 PM CEST 
//


package net.ihe.gazelle.cdagen.constraint.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import org.hibernate.annotations.Type;
import org.jboss.seam.annotations.Name;

import net.ihe.gazelle.hql.HQLQueryBuilder;


/**
 * <p>Java class for package complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="package"&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="name" type="{http://www.w3.org/2001/XMLSchema}string"/&gt;
 *         &lt;element name="description" type="{http://www.w3.org/2001/XMLSchema}string"/&gt;
 *         &lt;sequence maxOccurs="unbounded" minOccurs="0"&gt;
 *           &lt;element name="classe" type="{}classe"/&gt;
 *         &lt;/sequence&gt;
 *       &lt;/sequence&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@Entity
@Name("packageClass")
@Table(name="cons_package", schema="public", uniqueConstraints = @UniqueConstraint(columnNames = "id"))
@SequenceGenerator(name = "cons_package_sequence", sequenceName = "cons_package_id_seq", allocationSize=1)

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "package", propOrder = {
    "name",
    "description",
    "classe"
})
public class Packag implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@NotNull
	@Column(name="id", nullable = false, unique = true)
	@GeneratedValue(strategy=GenerationType.SEQUENCE, generator="cons_package_sequence")
	@XmlTransient
	private Integer id;

    @XmlElement(required = true)
    protected String name;
    
    @Lob
	@Type(type = "text")
    @XmlElement(required = true)
    protected String description;
    
    @XmlAttribute
    protected String xmlNamespace;
    
    @XmlAttribute
    protected String packageName;
    
    @OneToMany(mappedBy = "_package", fetch = FetchType.LAZY)
    protected List<Classe> classe;

    public void setClasse(List<Classe> classe) {
		this.classe = classe;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Integer getId() {
		return id;
	}

	public String getName() {
        return name;
    }

    public void setName(String value) {
        this.name = value;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String value) {
        this.description = value;
    }

    public List<Classe> getClasse() {
        if (classe == null) {
            classe = new ArrayList<>();
        }
        return this.classe;
    }
    
    public static List<Packag> getAllPackage(EntityManager em){
    	HQLQueryBuilder<Packag> hh = new HQLQueryBuilder<>(em, Packag.class);
    	return hh.getList();
    }
    
    public static void deletePackage(EntityManager em, Packag p){
    	if (p != null &&p.getId() != null){
			if (p.getClasse() != null){
				for (Classe cl : p.getClasse()) {
					Classe.deleteClasse(em, cl);
				}
			}
			p.setClasse(null);
			em.remove(p);
			em.flush();
    	}
    }

}
